/**
 */
package de.mdelab.mlcallactions;

import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Binary Operation Action</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Performs a binary operation on the operands. <!--
 * end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlcallactions.BinaryOperationAction#getOperator <em>
 * Operator</em>}</li>
 * <li>{@link de.mdelab.mlcallactions.BinaryOperationAction#getOperand1 <em>
 * Operand1</em>}</li>
 * <li>{@link de.mdelab.mlcallactions.BinaryOperationAction#getOperand2 <em>
 * Operand2</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getBinaryOperationAction()
 * @model
 * @generated
 */
public interface BinaryOperationAction extends CallAction
{
	/**
	 * Returns the value of the '<em><b>Operator</b></em>' attribute. The
	 * literals are from the enumeration
	 * {@link de.mdelab.mlcallactions.BinaryOperatorsEnum}. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Operator</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Operator</em>' attribute.
	 * @see de.mdelab.mlcallactions.BinaryOperatorsEnum
	 * @see #setOperator(BinaryOperatorsEnum)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getBinaryOperationAction_Operator()
	 * @model required="true"
	 * @generated
	 */
	BinaryOperatorsEnum getOperator();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction#getOperator
	 * <em>Operator</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Operator</em>' attribute.
	 * @see de.mdelab.mlcallactions.BinaryOperatorsEnum
	 * @see #getOperator()
	 * @generated
	 */
	void setOperator(BinaryOperatorsEnum value);

	/**
	 * Returns the value of the '<em><b>Operand1</b></em>' containment
	 * reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operand1</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Operand1</em>' containment reference.
	 * @see #setOperand1(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getBinaryOperationAction_Operand1()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getOperand1();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction#getOperand1
	 * <em>Operand1</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Operand1</em>' containment
	 *            reference.
	 * @see #getOperand1()
	 * @generated
	 */
	void setOperand1(MLExpression value);

	/**
	 * Returns the value of the '<em><b>Operand2</b></em>' containment
	 * reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operand2</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Operand2</em>' containment reference.
	 * @see #setOperand2(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getBinaryOperationAction_Operand2()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getOperand2();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction#getOperand2
	 * <em>Operand2</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Operand2</em>' containment
	 *            reference.
	 * @see #getOperand2()
	 * @generated
	 */
	void setOperand2(MLExpression value);

} // BinaryOperationAction
