/**
 */
package de.mdelab.mlcallactions;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Call Action Parameter</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Specifies the value of a parameter of the containing
 * CallAction. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlcallactions.CallActionParameter#getValueExpression
 * <em>Value Expression</em>}</li>
 * <li>{@link de.mdelab.mlcallactions.CallActionParameter#getCallAction <em>Call
 * Action</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getCallActionParameter()
 * @model
 * @generated
 */
public interface CallActionParameter extends MLElementWithUUID, MLAnnotatedElement, MLNamedElement, MLTypedElement
{
	/**
	 * Returns the value of the '<em><b>Value Expression</b></em>' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> The expressions that computes the parameter's value.
	 * <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Value Expression</em>' containment
	 *         reference.
	 * @see #setValueExpression(MLExpression)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getCallActionParameter_ValueExpression()
	 * @model containment="true" required="true"
	 * @generated
	 */
	MLExpression getValueExpression();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.CallActionParameter#getValueExpression
	 * <em>Value Expression</em>}' containment reference. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Value Expression</em>' containment
	 *            reference.
	 * @see #getValueExpression()
	 * @generated
	 */
	void setValueExpression(MLExpression value);

	/**
	 * Returns the value of the '<em><b>Call Action</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link de.mdelab.mlcallactions.ParameterizedCallAction#getParameters
	 * <em>Parameters</em>}'. <!-- begin-user-doc --> <!-- end-user-doc --> <!--
	 * begin-model-doc --> The CallAction that contains this parameter. <!--
	 * end-model-doc -->
	 * 
	 * @return the value of the '<em>Call Action</em>' container reference.
	 * @see #setCallAction(ParameterizedCallAction)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getCallActionParameter_CallAction()
	 * @see de.mdelab.mlcallactions.ParameterizedCallAction#getParameters
	 * @model opposite="parameters" required="true" transient="false"
	 * @generated
	 */
	ParameterizedCallAction getCallAction();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.CallActionParameter#getCallAction
	 * <em>Call Action</em>}' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Call Action</em>' container
	 *            reference.
	 * @see #getCallAction()
	 * @generated
	 */
	void setCallAction(ParameterizedCallAction value);

} // CallActionParameter
