/**
 */
package de.mdelab.mlcallactions.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.mdelab.mlcallactions.ActivityCallAction;
import de.mdelab.mlcallactions.BinaryOperationAction;
import de.mdelab.mlcallactions.BinaryOperatorsEnum;
import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlcallactions.CloneAction;
import de.mdelab.mlcallactions.EObjectReferenceAction;
import de.mdelab.mlcallactions.EOperationCallAction;
import de.mdelab.mlcallactions.LiteralDeclarationAction;
import de.mdelab.mlcallactions.MethodCallAction;
import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.NewObjectAction;
import de.mdelab.mlcallactions.NullValueAction;
import de.mdelab.mlcallactions.UnaryOperationAction;
import de.mdelab.mlcallactions.UnaryOperatorsEnum;
import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlcallactions.VariableReferenceAction;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class MlcallactionsFactoryImpl extends EFactoryImpl implements MlcallactionsFactory
{
	/**
	 * Creates the default factory implementation. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static MlcallactionsFactory init()
	{
		try
		{
			final MlcallactionsFactory theMlcallactionsFactory = (MlcallactionsFactory) EPackage.Registry.INSTANCE
					.getEFactory("http://www.mdelab.de/mlexpressions/mlcallactions/1.0");
			if (theMlcallactionsFactory != null)
			{
				return theMlcallactionsFactory;
			}
		}
		catch (final Exception exception)
		{
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MlcallactionsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public MlcallactionsFactoryImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EObject create(final EClass eClass)
	{
		switch (eClass.getClassifierID())
		{
			case MlcallactionsPackage.CALL_ACTION_EXPRESSION:
				return this.createCallActionExpression();
			case MlcallactionsPackage.LITERAL_DECLARATION_ACTION:
				return this.createLiteralDeclarationAction();
			case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION:
				return this.createVariableDeclarationAction();
			case MlcallactionsPackage.VARIABLE_REFERENCE_ACTION:
				return this.createVariableReferenceAction();
			case MlcallactionsPackage.NULL_VALUE_ACTION:
				return this.createNullValueAction();
			case MlcallactionsPackage.UNARY_OPERATION_ACTION:
				return this.createUnaryOperationAction();
			case MlcallactionsPackage.BINARY_OPERATION_ACTION:
				return this.createBinaryOperationAction();
			case MlcallactionsPackage.CLONE_ACTION:
				return this.createCloneAction();
			case MlcallactionsPackage.CALL_ACTION_PARAMETER:
				return this.createCallActionParameter();
			case MlcallactionsPackage.METHOD_CALL_ACTION:
				return this.createMethodCallAction();
			case MlcallactionsPackage.EOPERATION_CALL_ACTION:
				return this.createEOperationCallAction();
			case MlcallactionsPackage.NEW_OBJECT_ACTION:
				return this.createNewObjectAction();
			case MlcallactionsPackage.ACTIVITY_CALL_ACTION:
				return this.createActivityCallAction();
			case MlcallactionsPackage.EOBJECT_REFERENCE_ACTION:
				return this.createEObjectReferenceAction();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object createFromString(final EDataType eDataType, final String initialValue)
	{
		switch (eDataType.getClassifierID())
		{
			case MlcallactionsPackage.UNARY_OPERATORS_ENUM:
				return this.createUnaryOperatorsEnumFromString(eDataType, initialValue);
			case MlcallactionsPackage.BINARY_OPERATORS_ENUM:
				return this.createBinaryOperatorsEnumFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String convertToString(final EDataType eDataType, final Object instanceValue)
	{
		switch (eDataType.getClassifierID())
		{
			case MlcallactionsPackage.UNARY_OPERATORS_ENUM:
				return this.convertUnaryOperatorsEnumToString(eDataType, instanceValue);
			case MlcallactionsPackage.BINARY_OPERATORS_ENUM:
				return this.convertBinaryOperatorsEnumToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public CallActionExpression createCallActionExpression()
	{
		final CallActionExpressionImpl callActionExpression = new CallActionExpressionImpl();
		return callActionExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public LiteralDeclarationAction createLiteralDeclarationAction()
	{
		final LiteralDeclarationActionImpl literalDeclarationAction = new LiteralDeclarationActionImpl();
		return literalDeclarationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public VariableDeclarationAction createVariableDeclarationAction()
	{
		final VariableDeclarationActionImpl variableDeclarationAction = new VariableDeclarationActionImpl();
		return variableDeclarationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public VariableReferenceAction createVariableReferenceAction()
	{
		final VariableReferenceActionImpl variableReferenceAction = new VariableReferenceActionImpl();
		return variableReferenceAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NullValueAction createNullValueAction()
	{
		final NullValueActionImpl nullValueAction = new NullValueActionImpl();
		return nullValueAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public UnaryOperationAction createUnaryOperationAction()
	{
		final UnaryOperationActionImpl unaryOperationAction = new UnaryOperationActionImpl();
		return unaryOperationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public BinaryOperationAction createBinaryOperationAction()
	{
		final BinaryOperationActionImpl binaryOperationAction = new BinaryOperationActionImpl();
		return binaryOperationAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public CloneAction createCloneAction()
	{
		final CloneActionImpl cloneAction = new CloneActionImpl();
		return cloneAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public CallActionParameter createCallActionParameter()
	{
		final CallActionParameterImpl callActionParameter = new CallActionParameterImpl();
		return callActionParameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public MethodCallAction createMethodCallAction()
	{
		final MethodCallActionImpl methodCallAction = new MethodCallActionImpl();
		return methodCallAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EOperationCallAction createEOperationCallAction()
	{
		final EOperationCallActionImpl eOperationCallAction = new EOperationCallActionImpl();
		return eOperationCallAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NewObjectAction createNewObjectAction()
	{
		final NewObjectActionImpl newObjectAction = new NewObjectActionImpl();
		return newObjectAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ActivityCallAction createActivityCallAction()
	{
		final ActivityCallActionImpl activityCallAction = new ActivityCallActionImpl();
		return activityCallAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public EObjectReferenceAction createEObjectReferenceAction()
	{
		final EObjectReferenceActionImpl eObjectReferenceAction = new EObjectReferenceActionImpl();
		return eObjectReferenceAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public UnaryOperatorsEnum createUnaryOperatorsEnumFromString(final EDataType eDataType, final String initialValue)
	{
		final UnaryOperatorsEnum result = UnaryOperatorsEnum.get(initialValue);
		if (result == null)
		{
			throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertUnaryOperatorsEnumToString(final EDataType eDataType, final Object instanceValue)
	{
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public BinaryOperatorsEnum createBinaryOperatorsEnumFromString(final EDataType eDataType, final String initialValue)
	{
		final BinaryOperatorsEnum result = BinaryOperatorsEnum.get(initialValue);
		if (result == null)
		{
			throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName()
					+ "'");
		}
		return result;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertBinaryOperatorsEnumToString(final EDataType eDataType, final Object instanceValue)
	{
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public MlcallactionsPackage getMlcallactionsPackage()
	{
		return (MlcallactionsPackage) this.getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MlcallactionsPackage getPackage()
	{
		return MlcallactionsPackage.eINSTANCE;
	}

} // MlcallactionsFactoryImpl
