/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.Collection;
import java.util.HashSet;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlcallactions.ActivityCallAction;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlcallactions.ActivityCallAction} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ActivityCallActionItemProvider extends ParameterizedCallActionItemProvider implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource, ITableItemLabelProvider,
		ITableItemColorProvider, ITableItemFontProvider, IItemColorProvider, IItemFontProvider
{
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActivityCallActionItemProvider(final AdapterFactory adapterFactory)
	{
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(final Object object)
	{
		if (this.itemPropertyDescriptors == null)
		{
			super.getPropertyDescriptors(object);

			this.addActivityPropertyDescriptor(object);
			this.addReturnValueParameterPropertyDescriptor(object);
			this.addImportOutputParametersPropertyDescriptor(object);
		}
		return this.itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Activity feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addActivityPropertyDescriptor(final Object object)
	{
		this.itemPropertyDescriptors.add(this.createItemPropertyDescriptor(((ComposeableAdapterFactory) this.adapterFactory)
				.getRootAdapterFactory(), this.getResourceLocator(), this.getString("_UI_ActivityCallAction_activity_feature"), this
				.getString("_UI_PropertyDescriptor_description", "_UI_ActivityCallAction_activity_feature", "_UI_ActivityCallAction_type"),
				MlcallactionsPackage.Literals.ACTIVITY_CALL_ACTION__ACTIVITY, true, false, true, null, null, null));
	}

	/**
	 * This adds a property descriptor for the Return Value Parameter feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	protected void addReturnValueParameterPropertyDescriptor(final Object object)
	{
		// itemPropertyDescriptors.add(createItemPropertyDescriptor(
		// ((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(),
		// getResourceLocator(),
		// getString("_UI_ActivityCallAction_returnValueParameter_feature"),
		// getString("_UI_PropertyDescriptor_description",
		// "_UI_ActivityCallAction_returnValueParameter_feature",
		// "_UI_ActivityCallAction_type"),
		// MlcallactionsPackage.Literals.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER,
		// true,
		// false, true, null, null, null));

		this.itemPropertyDescriptors.add(new ItemPropertyDescriptor(((ComposeableAdapterFactory) this.adapterFactory)
				.getRootAdapterFactory(), this.getResourceLocator(), this.getString("_UI_ActivityCallAction_returnValueParameter_feature"),
				this.getString("_UI_PropertyDescriptor_description", "_UI_ActivityCallAction_returnValueParameter_feature",
						"_UI_ActivityCallAction_type"), MlcallactionsPackage.Literals.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER, true,
				false, true, null, null, null)
		{
			@Override
			protected Collection<?> getComboBoxObjects(final Object object)
			{
				assert object instanceof ActivityCallAction;

				final ActivityCallAction activityCallAction = (ActivityCallAction) object;

				final Collection<Object> set = new HashSet<Object>();

				if (activityCallAction.getActivity() != null)
				{
					for (final ActivityParameter activityParameter : activityCallAction.getActivity().getParameters())
					{
						if (activityParameter.getDirection() == ActivityParameterDirectionEnum.INOUT
								|| activityParameter.getDirection() == ActivityParameterDirectionEnum.OUT)
						{
							set.add(activityParameter);
						}
					}
				}

				return set;
			}
		});
	}

	/**
	 * This adds a property descriptor for the Import Output Parameters feature.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addImportOutputParametersPropertyDescriptor(final Object object)
	{
		this.itemPropertyDescriptors.add(this.createItemPropertyDescriptor(((ComposeableAdapterFactory) this.adapterFactory)
				.getRootAdapterFactory(), this.getResourceLocator(), this
				.getString("_UI_ActivityCallAction_importOutputParameters_feature"), this.getString("_UI_PropertyDescriptor_description",
				"_UI_ActivityCallAction_importOutputParameters_feature", "_UI_ActivityCallAction_type"),
				MlcallactionsPackage.Literals.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS, true, false, false,
				ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE, null, null));
	}

	/**
	 * This returns ActivityCallAction.gif. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(final Object object)
	{
		return this.overlayImage(object, this.getResourceLocator().getImage("full/obj16/ActivityCallAction"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String getText(final Object object)
	{
		final String label = ((ActivityCallAction) object).getUuid();
		return label == null || label.length() == 0 ? this.getString("_UI_ActivityCallAction_type") : this
				.getString("_UI_ActivityCallAction_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to
	 * update any cached children and by creating a viewer notification, which
	 * it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void notifyChanged(final Notification notification)
	{
		this.updateChildren(notification);

		switch (notification.getFeatureID(ActivityCallAction.class))
		{
			case MlcallactionsPackage.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS:
				this.fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(final Collection<Object> newChildDescriptors, final Object object)
	{
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
