/**
 */
package de.mdelab.mlcallactions.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import de.mdelab.mlcallactions.ActivityCallAction;
import de.mdelab.mlcallactions.BinaryOperationAction;
import de.mdelab.mlcallactions.CallAction;
import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.CallActionParameter;
import de.mdelab.mlcallactions.CloneAction;
import de.mdelab.mlcallactions.EObjectReferenceAction;
import de.mdelab.mlcallactions.EOperationCallAction;
import de.mdelab.mlcallactions.LiteralDeclarationAction;
import de.mdelab.mlcallactions.MethodCallAction;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.NewObjectAction;
import de.mdelab.mlcallactions.NullValueAction;
import de.mdelab.mlcallactions.ParameterizedCallAction;
import de.mdelab.mlcallactions.UnaryOperationAction;
import de.mdelab.mlcallactions.VariableDeclarationAction;
import de.mdelab.mlcallactions.VariableReferenceAction;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlcore.MLTypedElement;
import de.mdelab.mlexpressions.MLExpression;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see de.mdelab.mlcallactions.MlcallactionsPackage
 * @generated
 */
public class MlcallactionsSwitch<T> extends Switch<T>
{
	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static MlcallactionsPackage	modelPackage;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public MlcallactionsSwitch()
	{
		if (MlcallactionsSwitch.modelPackage == null)
		{
			MlcallactionsSwitch.modelPackage = MlcallactionsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(final EPackage ePackage)
	{
		return ePackage == MlcallactionsSwitch.modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns
	 * a non null result; it yields that result. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	@Override
	protected T doSwitch(final int classifierID, final EObject theEObject)
	{
		switch (classifierID)
		{
			case MlcallactionsPackage.CALL_ACTION_EXPRESSION:
			{
				final CallActionExpression callActionExpression = (CallActionExpression) theEObject;
				T result = this.caseCallActionExpression(callActionExpression);
				if (result == null)
				{
					result = this.caseMLExpression(callActionExpression);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(callActionExpression);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(callActionExpression);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.CALL_ACTION:
			{
				final CallAction callAction = (CallAction) theEObject;
				T result = this.caseCallAction(callAction);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(callAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(callAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(callAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.LITERAL_DECLARATION_ACTION:
			{
				final LiteralDeclarationAction literalDeclarationAction = (LiteralDeclarationAction) theEObject;
				T result = this.caseLiteralDeclarationAction(literalDeclarationAction);
				if (result == null)
				{
					result = this.caseCallAction(literalDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(literalDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(literalDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(literalDeclarationAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.VARIABLE_DECLARATION_ACTION:
			{
				final VariableDeclarationAction variableDeclarationAction = (VariableDeclarationAction) theEObject;
				T result = this.caseVariableDeclarationAction(variableDeclarationAction);
				if (result == null)
				{
					result = this.caseCallAction(variableDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(variableDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(variableDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(variableDeclarationAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(variableDeclarationAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.VARIABLE_REFERENCE_ACTION:
			{
				final VariableReferenceAction variableReferenceAction = (VariableReferenceAction) theEObject;
				T result = this.caseVariableReferenceAction(variableReferenceAction);
				if (result == null)
				{
					result = this.caseCallAction(variableReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(variableReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(variableReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(variableReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(variableReferenceAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.NULL_VALUE_ACTION:
			{
				final NullValueAction nullValueAction = (NullValueAction) theEObject;
				T result = this.caseNullValueAction(nullValueAction);
				if (result == null)
				{
					result = this.caseCallAction(nullValueAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(nullValueAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(nullValueAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(nullValueAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.UNARY_OPERATION_ACTION:
			{
				final UnaryOperationAction unaryOperationAction = (UnaryOperationAction) theEObject;
				T result = this.caseUnaryOperationAction(unaryOperationAction);
				if (result == null)
				{
					result = this.caseCallAction(unaryOperationAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(unaryOperationAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(unaryOperationAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(unaryOperationAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.BINARY_OPERATION_ACTION:
			{
				final BinaryOperationAction binaryOperationAction = (BinaryOperationAction) theEObject;
				T result = this.caseBinaryOperationAction(binaryOperationAction);
				if (result == null)
				{
					result = this.caseCallAction(binaryOperationAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(binaryOperationAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(binaryOperationAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(binaryOperationAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.CLONE_ACTION:
			{
				final CloneAction cloneAction = (CloneAction) theEObject;
				T result = this.caseCloneAction(cloneAction);
				if (result == null)
				{
					result = this.caseCallAction(cloneAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(cloneAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(cloneAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(cloneAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.CALL_ACTION_PARAMETER:
			{
				final CallActionParameter callActionParameter = (CallActionParameter) theEObject;
				T result = this.caseCallActionParameter(callActionParameter);
				if (result == null)
				{
					result = this.caseMLElementWithUUID(callActionParameter);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(callActionParameter);
				}
				if (result == null)
				{
					result = this.caseMLNamedElement(callActionParameter);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(callActionParameter);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.PARAMETERIZED_CALL_ACTION:
			{
				final ParameterizedCallAction parameterizedCallAction = (ParameterizedCallAction) theEObject;
				T result = this.caseParameterizedCallAction(parameterizedCallAction);
				if (result == null)
				{
					result = this.caseCallAction(parameterizedCallAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(parameterizedCallAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(parameterizedCallAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(parameterizedCallAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.METHOD_CALL_ACTION:
			{
				final MethodCallAction methodCallAction = (MethodCallAction) theEObject;
				T result = this.caseMethodCallAction(methodCallAction);
				if (result == null)
				{
					result = this.caseParameterizedCallAction(methodCallAction);
				}
				if (result == null)
				{
					result = this.caseCallAction(methodCallAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(methodCallAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(methodCallAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(methodCallAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.EOPERATION_CALL_ACTION:
			{
				final EOperationCallAction eOperationCallAction = (EOperationCallAction) theEObject;
				T result = this.caseEOperationCallAction(eOperationCallAction);
				if (result == null)
				{
					result = this.caseParameterizedCallAction(eOperationCallAction);
				}
				if (result == null)
				{
					result = this.caseCallAction(eOperationCallAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(eOperationCallAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(eOperationCallAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(eOperationCallAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.NEW_OBJECT_ACTION:
			{
				final NewObjectAction newObjectAction = (NewObjectAction) theEObject;
				T result = this.caseNewObjectAction(newObjectAction);
				if (result == null)
				{
					result = this.caseParameterizedCallAction(newObjectAction);
				}
				if (result == null)
				{
					result = this.caseCallAction(newObjectAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(newObjectAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(newObjectAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(newObjectAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.ACTIVITY_CALL_ACTION:
			{
				final ActivityCallAction activityCallAction = (ActivityCallAction) theEObject;
				T result = this.caseActivityCallAction(activityCallAction);
				if (result == null)
				{
					result = this.caseParameterizedCallAction(activityCallAction);
				}
				if (result == null)
				{
					result = this.caseCallAction(activityCallAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(activityCallAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(activityCallAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(activityCallAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			case MlcallactionsPackage.EOBJECT_REFERENCE_ACTION:
			{
				final EObjectReferenceAction eObjectReferenceAction = (EObjectReferenceAction) theEObject;
				T result = this.caseEObjectReferenceAction(eObjectReferenceAction);
				if (result == null)
				{
					result = this.caseCallAction(eObjectReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLElementWithUUID(eObjectReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLAnnotatedElement(eObjectReferenceAction);
				}
				if (result == null)
				{
					result = this.caseMLTypedElement(eObjectReferenceAction);
				}
				if (result == null)
				{
					result = this.defaultCase(theEObject);
				}
				return result;
			}
			default:
				return this.defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Call Action Expression</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Call Action Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallActionExpression(final CallActionExpression object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Call Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallAction(final CallAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Literal Declaration Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Literal Declaration Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLiteralDeclarationAction(final LiteralDeclarationAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Variable Declaration Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Variable Declaration Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVariableDeclarationAction(final VariableDeclarationAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Variable Reference Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Variable Reference Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVariableReferenceAction(final VariableReferenceAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Null Value Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Null Value Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNullValueAction(final NullValueAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Unary Operation Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Unary Operation Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseUnaryOperationAction(final UnaryOperationAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Binary Operation Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Binary Operation Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBinaryOperationAction(final BinaryOperationAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Clone Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Clone Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCloneAction(final CloneAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Call Action Parameter</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Call Action Parameter</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallActionParameter(final CallActionParameter object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Parameterized Call Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Parameterized Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseParameterizedCallAction(final ParameterizedCallAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Method Call Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Method Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMethodCallAction(final MethodCallAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>EOperation Call Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>EOperation Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEOperationCallAction(final EOperationCallAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>New Object Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>New Object Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNewObjectAction(final NewObjectAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>Activity Call Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>Activity Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityCallAction(final ActivityCallAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>EObject Reference Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>EObject Reference Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEObjectReferenceAction(final EObjectReferenceAction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Element With UUID</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Element With UUID</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLElementWithUUID(final MLElementWithUUID object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Annotated Element</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLAnnotatedElement(final MLAnnotatedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Expression</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLExpression(final MLExpression object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Typed Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Typed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLTypedElement(final MLTypedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>ML Named Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>ML Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMLNamedElement(final MLNamedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '
	 * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpreting the object as an instance of '
	 *         <em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(final EObject object)
	{
		return null;
	}

} // MlcallactionsSwitch
